#!/usr/bin/perl
#*******************************************************************#
#  Init_3rdparty - prepare DSM to use PHP                           #
#  Modul:       set_permissions.pl                                  #
#  Description: a perl script to set file and folder permissions    #
#  Author:      QTip from the german Synology support forum         #
#  Copyright:   2015-2017 by QTip                                   #
#  License:     GNU GPLv3 (see LICENSE)                             #
#  ---------------------------------------------------------------  #
#  Version:     0.1 - 24/02/2017                                    #
#  for more information check the changelog                         #
#*******************************************************************#

use strict;
use warnings;

my $itphome = "/var/packages/Init_3rdparty/target";
my $itpetc = "/var/packages/Init_3rdparty/etc";

sub set_permissions {
     my $path = shift;

     opendir(my $handle, $path) or die $!;
     while(my $e = readdir($handle)) {
          next if ($e =~ /^(\.\.?|\.svn|tmp|log)$/);
          chown(0,0,"$path/$e");
          if(-d "$path/$e") {
              chmod(0755,"$path/$e");
              set_permissions("$path/$e");
          } elsif ($e =~ /^(.*\.pl|.*\.cgi|.*\.sh)$/) {
              chmod(0755,"$path/$e");
          } else {
              chmod(0644,"$path/$e");
          }
     }
     closedir($handle);
}
set_permissions($itphome);
set_permissions($itpetc);
exit;
