#!/bin/sh
#********************************************************************#
#  php_status.sh                                                     #
#  Description: Script to detect all installed and started php       #
#               versions, can restart php-fpm instance               #
#  Author:      QTip from the german Synology support forum          #
#  Copyright:   2016-2017 by QTip                                    #
#  License:     GNU GPLv3                                            #
#  ----------------------------------------------------------------  #
#  Version:     0.26 - 24/02/2017                                    #
#********************************************************************#

PHPPACKNAMES="PHP5.6 PHP7.0"
ACTIVE=0
PHPACTIVE=`/bin/cat /var/packages/Init_3rdparty/etc/active_php 2> /dev/null`
[ -z "${PHPACTIVE}" ] && PHPACTIVE=""
PHPVERSIONS=
DSMMAJOR=`/bin/get_key_value /etc.defaults/VERSION majorversion`
SYNOPKGCMD="/usr/syno/bin/synopkg"

status_pkg() {
     local RET
     RET=`${SYNOPKGCMD} status "${1}"`
     if [ `echo -n ${RET} | /bin/grep -c "started"` -eq 1 ] ; then
          return 1
     else
          return 0
     fi
}
case $1 in
     status)
          if [ ${DSMMAJOR} -ge 6 ] ; then
               status_pkg "${PHPACTIVE}"
               [ "$?" == "0" ] && PHPACTIVE=
               for IDX in ${PHPPACKNAMES}; do
                    status_pkg "${IDX}"
                    if [ "$?" == "1" ] ; then
                         if [ -n "${PHPACTIVE}" ] ; then
                              if [ "${IDX}" == "${PHPACTIVE}" ] ; then
                                   PHPVERSIONS="${PHPVERSIONS}${IDX},1\n"
                              else
                                   PHPVERSIONS="${PHPVERSIONS}${IDX},0\n"
                              fi
                         else
                              if [ ${ACTIVE} -eq 0 ] ; then
                                   PHPVERSIONS="${PHPVERSIONS}${IDX},1\n"
                                   ACTIVE=1
                              else
                                   PHPVERSIONS="${PHPVERSIONS}${IDX},0\n"
                              fi
                         fi
                    fi
               done
          else
               PHPVERSIONS="PHP5,1\n"
          fi
          echo -e ${PHPVERSIONS}
     ;;
esac
